"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PropTypes = require("prop-types");
var React = require("react");
var Media_1 = require("./Media");
var react_1 = require("react");
var utils_1 = require("./utils");
var castPointsTo = function (points, targetType) {
    return Object.keys(points).reduce(function (acc, key) {
        acc[key] = targetType;
        return acc;
    }, {});
};
var skipProp = {};
// @ts-ignore
var use = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return null;
};
function createMediaMatcher(queries, firstKey) {
    use(firstKey);
    var mediaDefaults = Media_1.executeMediaQuery(queries);
    var initialValue = {};
    var MediaContext = React.createContext(initialValue);
    var getMediaMatches = function (matches) { return (matches === initialValue ? mediaDefaults : matches); };
    var consume = function (cb) { return (React.createElement(MediaContext.Consumer, null, function (matched) { return cb(getMediaMatches(matched)); })); };
    function pickMatch(matches, slots, defaultValue) {
        return utils_1.pickMediaMatch(queries, matches, slots, defaultValue);
    }
    function useMedia(slots, defaultValue) {
        var matches = getMediaMatches(React.useContext(MediaContext));
        if (process.env.NODE_ENV !== 'production') {
            react_1.useDebugValue(utils_1.pickMediaMatchSlot(queries, matches, slots) || 'default');
        }
        return pickMatch(matches, slots, defaultValue);
    }
    function pickMatchEx(matches, slots) {
        return utils_1.pickMediaMatch(queries, matches, slots);
    }
    var ProvideMediaMatchers = function (_a) {
        var children = _a.children, _b = _a.state, state = _b === void 0 ? null : _b;
        return (React.createElement(MediaContext.Consumer, null, function (parentMatch) { return (React.createElement(Media_1.Media, { queries: queries }, function (matches) {
            var value = state || __assign({}, utils_1.notNulls(matches), (parentMatch || {}));
            return React.createElement(MediaContext.Provider, { value: value, children: children });
        })); }));
    };
    ProvideMediaMatchers.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? {
                state: PropTypes.shape(__assign({}, castPointsTo(queries, PropTypes.bool))),
            }
            : skipProp;
    var MediaMatches = function (_a) {
        var children = _a.children;
        return consume(function (matched) { return children(matched, function (matches) { return pickMatch(matched, matches); }); });
    };
    MediaMatches.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? {
                children: PropTypes.func.isRequired,
            }
            : skipProp;
    var InlineMediaMatcher = function (props) {
        return consume(function (matched) { return pickMatchEx(matched, props); });
    };
    var MediaMatcher = function (props) {
        return consume(function (matched) { return pickMatchEx(matched, props); });
    };
    MediaMatcher.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? __assign({}, castPointsTo(queries, PropTypes.node)) : skipProp;
    var Mock = function (_a) {
        var children = _a.children, props = __rest(_a, ["children"]);
        return (React.createElement(MediaContext.Provider, { value: utils_1.pickMatchValues(queries, __assign({}, utils_1.nothingSet(queries), props)) }, children));
    };
    var Override = function (_a) {
        var children = _a.children, props = __rest(_a, ["children"]);
        return (React.createElement(MediaContext.Consumer, null, function (parentMatch) {
            var value = __assign({}, utils_1.notNulls(parentMatch), utils_1.pickMatchValues(queries, props));
            return React.createElement(MediaContext.Provider, { value: value, children: children });
        }));
    };
    var Below = function (_a) {
        var children = _a.children, including = _a.including, props = __rest(_a, ["children", "including"]);
        return (React.createElement(MediaMatcher, __assign({}, utils_1.inBetween(queries, props, children, including ? false : true, true))));
    };
    var Above = function (_a) {
        var children = _a.children, including = _a.including, props = __rest(_a, ["children", "including"]);
        return (React.createElement(MediaMatcher, __assign({}, utils_1.inBetween(queries, props, children, including ? true : false, false))));
    };
    var MediaServerSide = function (_a) {
        var predicted = _a.predicted, _b = _a.hydrated, hydrated = _b === void 0 ? false : _b, children = _a.children;
        var _c = react_1.useState(hydrated), isHydrated = _c[0], setHydrated = _c[1];
        var media = React.useContext(MediaContext);
        react_1.useEffect(function () {
            setHydrated(true);
        }, []);
        var overrides = react_1.useMemo(function () {
            var _a;
            if (isHydrated) {
                return media;
            }
            else {
                return __assign({}, utils_1.nothingSet(queries), (_a = {}, _a[predicted] = true, _a));
            }
        }, [media, isHydrated]);
        return React.createElement(MediaContext.Provider, { value: overrides, children: children });
    };
    var ServerRender = function (_a) {
        var predicted = _a.predicted, hydrated = _a.hydrated, children = _a.children;
        return (React.createElement(ProvideMediaMatchers, null,
            React.createElement(MediaServerSide, { predicted: predicted, hydrated: hydrated, children: children })));
    };
    return {
        queries: queries,
        pickMatch: pickMatch,
        useMedia: useMedia,
        Provider: ProvideMediaMatchers,
        Mock: Mock,
        Override: Override,
        //
        Matches: MediaMatches,
        Inline: InlineMediaMatcher,
        Above: Above,
        Below: Below,
        //
        Matcher: MediaMatcher,
        ServerRender: ServerRender,
        //
        Gearbox: MediaContext.Consumer,
        Consumer: MediaContext.Consumer,
    };
}
exports.createMediaMatcher = createMediaMatcher;
